#if defined bf2_core_included
  #endinput
#endif
#define bf2_core_included

#define ADMIN_FLAG_X ( 1 << 23 )
#define ADMIN_LEVEL ADMIN_FLAG_X
#define DMG_HE ( 1 << 24 )

#define MAX_RANKS 17
#define MAX_BADGES 8
#define MAX 32

#define BADGE_KNIFE 0
#define BADGE_PISTOL 1
#define BADGE_ASSAULT 2
#define BADGE_SNIPER 3
#define BADGE_SUPPORT 4
#define BADGE_EXPLOSIVES 5
#define BADGE_SHOTGUN 6
#define BADGE_SMG 7

#define LEVEL_NONE 0
#define LEVEL_BASIC 1
#define LEVEL_VETERAN 2
#define LEVEL_EXPERT 3
#define LEVEL_PROFESIONAL 4

#define MENU_MAIN 1
#define MENU_HELP 2
#define MENU_STATS 3
#define MENU_ADMIN 4
#define MENU_CONFIRM 5
#define MENU_CONFIRMADMIN 6
#define MENU_BADGE 7
#define MENU_LEVEL 8
#define MENU_PLAYER 9

#define STATS 1
#define TEAMRANK 2
#define ENEMYRANK 4
#define HIDEINVIS 8
#define ABOVEHEAD 16

#define NEGATIVE_SECONDSINDAY -86400

#define MEDAL_BRONZE 1
#define MEDAL_SILVER 2
#define MEDAL_GOLD 3

enum PluginInfo { piAutor[ 128 ],	piWersja[ 128 ], piNazwa[ 128 ] };
new gPluginInfo[ PluginInfo ] = { "MisieQ", "1.3.1", "Battlefield 2: Rank Mod" };
enum PluginCvar { pcBazaHost[ 128 ], pcBazaUser[ 128 ], pcBazaHaslo[ 128 ], pcBazaNazwa[ 128 ] };
new gPluginCvar[ PluginCvar ] = { "host bazy danych", "user bazy danych", "haslo bazy danych", "baza danych" };
enum PluginSounds { psPoziom, psOdznaka, };
stock const gPluginSounds[ PluginSounds ][ 128 ] = { "bf2/Poziom.wav", "bf2/Odznaka.wav" };
enum _:cvar { 
	ACTIVE, BADGESACTIVE, FREEAWP, XPMULTI, XPMINI,
	ICONTIME, HELPURL, BADGESPOWERS, HUDOPTIONS, STATUSTEXT,
	FFA, SAVETYPE, SVLAN, WYMUS
};
new gPcvar[ cvar ];
enum PlayerStats { 
	psKnfie, psPistol, psSniper, psPara, psDefuses,
	psPlants, psExplosions, psAccuracy, psTotal, psSmg,
	psShotgun, psRifle, psGrenade, psBronze, psSilver,
	psGold
};
new gPlayerStats[ MAX + 1 ][ PlayerStats ];
enum MostStats { msKills, msKillsID, msKillsName[ MAX ], msWins, msWinsName[ MAX ] };
new gMost[ MostStats ];
enum Configs { cDir[ 200 ], cFile[ 200 ] };
new gConfig[ Configs ];
enum HighStats { hsRank,	hsRankID, hsRankServer, hsRankServerName[ MAX ] };
new gHighest[ HighStats ];
enum Msg { mStatusText, mScreenFade, mScreenShake, }
new gMsg[ Msg ];

new bool:newplayer[ MAX + 1 ], bool:g_imobile[ MAX + 1 ], bool:g_invis[ MAX + 1 ],
	bool:freezetime, bool:SQLenabled, bool:gIntermission;

new gSaveKey[ MAX + 1 ][ MAX ], gStatsLoaded[ MAX + 1 ], gCurrentFOV[ MAX + 1 ],
	gSprite[ 22 ], gPlayerName, gHudSyncAimInfo;
	
new Handle:g_SqlTuple, Handle:g_SqlTuple2;

new g_Cache[ 512 ], g_PlayerRank[ MAX + 1 ], g_PlayerBadges[ MAX + 1 ][ MAX_BADGES ], g_friend[ MAX + 1 ], g_lastwpn[ MAX + 1 ];

new menuselected[ MAX + 1 ][ 3 ], numofbadges[ MAX + 1 ], menuselection[ MAX + 1 ];

new const gRankName[ MAX_RANKS + 5 ][ ] = { 
	"Szeregowy", "Starszy Szeregowy", "Kapral", "Starszy Kapral", "Plutonowy",
	"Sierzant", "Starszy Sierzant", "Mlodyszy Chorazy", "Chorazy", "Starszy Chorazy",
	"Chorazy Sztabowy", "Podporucznik", "Porucznik", "Kapitan", "Major",
	"Podpulkownik", "Pulkownik", "General Brygady", "General Dywizji", "General Broni", "General",
	"Marszalek Polski" };

new const Float:gRankOrder[ MAX_RANKS + 5 ] = { 
	0.0, 1.0, 2.0, 3.0, 4.0,
	5.0, 6.0, 7.0, 8.0, 9.0,
	10.0, 11.0, 12.0, 13.0, 14.0,
	15.0, 16.0, 7.5, 8.5, 15.5,
	20.0
};

new const gRankXP[ MAX_RANKS ] = { 
	0, 150, 500, 800, 2500,
	5000, 8000, 20000, 50000, 60000,
	75000, 90000, 115000, 125000, 150000,
	180000, 200000
};

new const gBadgeName[ MAX_BADGES ][ 5 ][ ] = {
	{ "", "Podstawowa walka Nozem", "Weteran w walce Nozem", "Expert w walce Nozem", "Profesjonalista w walce Nozem" },
	{ "", "Podstawowa walka Pistoletem", "Weteran w walce z Pistoletem", "Expert w walce z Pistoletem", "Profesjonalista w walce z Pistoletem" },
	{ "", "Podstawowa walka Bronia Szturmowa", "Weteran w walce z Bronia Szturmowa", "Expert w walce z Bronia Szturmowa", "Profesjonalista w walce z Bronia Szturmowa" },
	{ "", "Podstawowa walka Bronia Snajperska", "Weteran w walce z Bronia Snajperska", "Expert w walce z Bronia Snajperska", "Profesjonalista w walce z Bronia Snajperska" },
	{ "", "Poczatkujacy w walce Bronia Wsparcia", "Weteran w walce Bronia Wsparcia", "Expert w walce Bronia Wsparcia", "Profesjonalista w walce Bronia Wsparcia" },
	{ "", "Podstawowe obeznanie w Materialach Wybuchowych", "Weteran w obeznaniu w Materialach Wybuchowych", "Expert w obeznaniu w Materialach Wybuchowych", "Profesjonalista w obeznaniu w Materialach Wybuchowych"},
	{ "", "Podstawowa walka z Shotgunem", "Weteran w walce z Shotgunem", "Expert w walce z Shotgunem", "Profesjonalista w walce z Shotgunem" },
	{ "", "Podstawowa walka z SMG", "Weteran w walce z SMG", "Expert w walce z SMG", "Profesjonalista w walce z SMG" }
};

new const gBadgeInfo[ MAX_BADGES ][ ] = {
	"Dostaje % z zadanych obrazen za pomoca noza w postaci HP",
	"Szansa na unieszkodliwienie atkujacego na 1 sekunde",
	"Dostaje dodatkowe HP na respie",
	"Dostaje Darmowa snajperke na respie",
	"Dodatkowe obrazenia z M249",
	"Wieksze obrazenia z granatow",
	"Niewidzialnosc z nozem",
	"Buty Szybkosci"
};

new const gInvisAlphaValue[ 4 ] = { 
	150, 100, 70, 40
};

new Float:gCSWeaponSpeed[ MAX ] = { 
	0.0, 250.0, 0.0, 260.0, 250.0,
	240.0, 250.0, 250.0, 240.0, 250.0,
	250.0, 250.0, 250.0, 210.0, 240.0,
	240.0, 250.0, 250.0, 210.0, 250.0,
	220.0, 230.0, 230.0, 250.0, 210.0,
	250.0, 250.0, 235.0, 221.0, 250.0,
	245.0
};