#if defined bf2_sql_included
  #endinput
#endif
#define bf2_sql_included

public sql_init( )
{
	g_SqlTuple = SQL_MakeDbTuple( gPluginCvar[ pcBazaHost ], gPluginCvar[ pcBazaUser ], gPluginCvar[ pcBazaHaslo ], gPluginCvar[ pcBazaNazwa ] );
	g_SqlTuple2 = SQL_MakeDbTuple( gPluginCvar[ pcBazaHost ], gPluginCvar[ pcBazaUser ], gPluginCvar[ pcBazaHaslo ], gPluginCvar[ pcBazaNazwa ] );

	SQL_ThreadQuery( g_SqlTuple, "TableHandle", "CREATE TABLE IF NOT EXISTS bf2ranks ( playerid VARCHAR( 35 ), badge1 TINYINT( 4 ), badge2 TINYINT( 4 ), badge3 TINYINT( 4 ), badge4 TINYINT( 4 ), badge5 TINYINT( 4 ), badge6 TINYINT( 4 ), knife SMALLINT( 6 ), pistol SMALLINT( 6 ), sniper SMALLINT( 6 ), support SMALLINT( 6 ), kills INT( 11 ), defuses INT( 11 ), plants INT( 11 ), explosions INT( 11 ), PRIMARY KEY ( playerid ) )" );
	SQL_ThreadQuery( g_SqlTuple2, "TableHandle", "CREATE TABLE IF NOT EXISTS bf2ranks2 ( playerid VARCHAR( 35 ), badge7 TINYINT( 4 ), badge8 TINYINT( 4 ), shotgun SMALLINT( 6 ), smg SMALLINT( 6 ), rifle SMALLINT( 6 ), grenade SMALLINT( 6 ), gold INT( 11 ), silver INT( 11 ), bronze INT( 11 ), highestrank VARCHAR( 35 ), mostkills VARCHAR( 35 ), mostwins VARCHAR( 35 ), PRIMARY KEY ( playerid ) )" );
}

public sql_load( id ) {
	new index[ 1 ];
	index[ 0 ] = id;

	new tempSaveKey[ 63 ];
	copy( tempSaveKey, charsmax( tempSaveKey ), gSaveKey[ id ] );
	replace_all( tempSaveKey, charsmax( tempSaveKey ), "'", "\'" );

	formatex( g_Cache, charsmax( g_Cache ), "SELECT badge1, badge2, badge3, badge4, badge5, badge6, knife, pistol, sniper, support, kills, defuses, plants, explosions FROM bf2ranks WHERE playerid='%s'", tempSaveKey );
	SQL_ThreadQuery( g_SqlTuple, "SelectHandle", g_Cache, index, 1 );

	formatex( g_Cache, charsmax( g_Cache ), "SELECT badge7, badge8, shotgun, smg, rifle, grenade, gold, silver, bronze FROM bf2ranks2 WHERE playerid='%s'", tempSaveKey );
	SQL_ThreadQuery( g_SqlTuple2, "SelectHandle2", g_Cache, index, 1 );
}

public sql_server_load( ) {
	SQL_ThreadQuery( g_SqlTuple, "SelectHandleServer", "SELECT gold, silver, bronze, highestrank, mostkills, mostwins FROM bf2ranks2 WHERE playerid='Server'" );
}

public sql_save( id ) {
	if ( gStatsLoaded[ id ] >= 2 ) {
		if ( gIntermission ) {
			sql_save_nonthreaded( id );
			return;
		}

		new tempSaveKey[ 63 ];
		copy( tempSaveKey, charsmax( tempSaveKey ), gSaveKey[ id ] );
		replace_all( tempSaveKey, charsmax( tempSaveKey ), "'", "\'" );

		formatex( g_Cache, charsmax( g_Cache ), "UPDATE bf2ranks SET badge1=%i, badge2=%i, badge3=%i, badge4=%i, badge5=%i, badge6=%i, knife=%i, pistol=%i, sniper=%i, support=%i, kills=%i, defuses=%i, plants=%i, explosions=%i WHERE playerid=^"%s^"",
		g_PlayerBadges[ id ][ BADGE_KNIFE ], g_PlayerBadges[ id ][ BADGE_PISTOL ], g_PlayerBadges[ id ][ BADGE_ASSAULT ], g_PlayerBadges[ id ][ BADGE_SNIPER ], g_PlayerBadges[ id ][ BADGE_SUPPORT ], g_PlayerBadges[ id ][ BADGE_EXPLOSIVES ], gPlayerStats[ id ][ psKnfie ], gPlayerStats[ id ][ psPistol ], gPlayerStats[ id ][ psSniper ], gPlayerStats[ id ][ psPara ], gPlayerStats[ id ][ psTotal ], gPlayerStats[ id ][ psDefuses ], gPlayerStats[ id ][ psPlants ], gPlayerStats[ id ][ psExplosions ], tempSaveKey );
		SQL_ThreadQuery( g_SqlTuple, "QueryHandle", g_Cache );

		formatex( g_Cache, charsmax( g_Cache ), "UPDATE bf2ranks2 SET badge7=%i, badge8=%i, shotgun=%i, smg=%i, rifle=%i, grenade=%i, gold=%i, silver=%i, bronze=%i WHERE playerid=^"%s^"", g_PlayerBadges[ id ][ BADGE_SHOTGUN ], g_PlayerBadges[ id ][ BADGE_SMG ], gPlayerStats[ id ][ psShotgun ], gPlayerStats[ id ][ psSmg ], gPlayerStats[ id ][ psRifle ], gPlayerStats[ id ][ psGrenade ], gPlayerStats[ id ][ psGold ], gPlayerStats[ id ][ psSilver ], gPlayerStats[ id ][ psBronze ], tempSaveKey );
		SQL_ThreadQuery( g_SqlTuple2, "QueryHandle", g_Cache );
	}
}

sql_save_nonthreaded( id ) {
	new Errcode, Error[ 128 ], Handle:SqlConnection, Handle:SqlConnection2;

	SqlConnection = SQL_Connect( g_SqlTuple, Errcode, Error, charsmax( Error ) );
	SqlConnection2 = SQL_Connect( g_SqlTuple2, Errcode, Error, charsmax( Error ) );

	if ( !SqlConnection ) {
		log_amx( "Save - Could not connect to SQL database.  [ %d ] %s", Errcode, Error );
		SQL_FreeHandle( SqlConnection );
		return;
	}
	
	if ( !SqlConnection2 ) {
		log_amx( "Save - Could not connect to SQL database.  [ %d ] %s", Errcode, Error );
		SQL_FreeHandle( SqlConnection2 );
		return;
	}

	new tempSaveKey[ 63 ];
	copy( tempSaveKey, charsmax( tempSaveKey ), gSaveKey[ id ] );
	replace_all( tempSaveKey, charsmax( tempSaveKey ), "'", "\'" );

	new Handle:Query;
	Query = SQL_PrepareQuery( SqlConnection, "UPDATE bf2ranks SET badge1=%i, badge2=%i, badge3=%i, badge4=%i, badge5=%i, badge6=%i, knife=%i, pistol=%i, sniper=%i, support=%i, kills=%i, defuses=%i, plants=%i, explosions=%i WHERE playerid=^"%s^"",
	g_PlayerBadges[ id ][ BADGE_KNIFE ], g_PlayerBadges[ id ][ BADGE_PISTOL ], g_PlayerBadges[ id ][ BADGE_ASSAULT ], g_PlayerBadges[ id ][ BADGE_SNIPER ], g_PlayerBadges[ id ][ BADGE_SUPPORT ], g_PlayerBadges[ id ][ BADGE_EXPLOSIVES ], gPlayerStats[ id ][ psKnfie ], gPlayerStats[ id ][ psPistol ], gPlayerStats[ id ][ psSniper ], gPlayerStats[ id ][ psPara ], gPlayerStats[ id ][ psTotal ], gPlayerStats[ id ][ psDefuses ], gPlayerStats[ id ][ psPlants ], gPlayerStats[ id ][ psExplosions ], tempSaveKey );
	if ( !SQL_Execute( Query ) ) {
		Errcode = SQL_QueryError( Query, Error, charsmax( Error ) );
		log_amx( "Save Query failed. [ %d ] %s", Errcode, Error );
		SQL_FreeHandle( Query );
		SQL_FreeHandle( SqlConnection );
		return;
	}
	SQL_FreeHandle( Query );

	Query = SQL_PrepareQuery( SqlConnection2, "UPDATE bf2ranks2 SET badge7=%i,badge8=%i, shotgun=%i, smg=%i, rifle=%i, grenade=%i, gold=%i, silver=%i, bronze=%i WHERE playerid=^"%s^"", g_PlayerBadges[ id ][ BADGE_SHOTGUN ], g_PlayerBadges[ id ][ BADGE_SMG ], gPlayerStats[ id ][ psShotgun ], gPlayerStats[ id ][ psSmg ], gPlayerStats[ id ][ psRifle ], gPlayerStats[ id ][ psGrenade ], gPlayerStats[ id ][ psGold ], gPlayerStats[ id ][ psSilver ], gPlayerStats[ id ][ psBronze ], tempSaveKey );
	if ( !SQL_Execute( Query ) ) {
		Errcode = SQL_QueryError( Query, Error, charsmax( Error ) );
		log_amx( "Save Query failed. [ %d ] %s", Errcode, Error );
	}

	SQL_FreeHandle( Query );
	SQL_FreeHandle( SqlConnection );
	SQL_FreeHandle( SqlConnection2 );
}

public sql_server_save( ) {
	new Errcode, Error[ 128 ], Handle:SqlConnection;

	SqlConnection = SQL_Connect( g_SqlTuple2, Errcode, Error, charsmax( Error ) );

	if ( !SqlConnection ) {
		log_amx( "Save - Could not connect to SQL database.  [ %d ] %s", Errcode, Error );
		SQL_FreeHandle( SqlConnection );
		return;
	}

	new tempTopName[ 63 ], tempPtsName[ 63 ], tempWinsName[ 63 ];
	copy( tempTopName, charsmax( tempTopName ), gHighest[ hsRankServerName ] );
	copy( tempPtsName, charsmax( tempPtsName ), gMost[ msKillsName ] );
	copy( tempWinsName, charsmax( tempWinsName ), gMost[ msWinsName ] );

	replace_all( tempTopName, charsmax( tempTopName ), "'", "\'" );
	replace_all( tempPtsName, charsmax( tempPtsName ), "'", "\'" );
	replace_all( tempWinsName, charsmax( tempWinsName ), "'", "\'" );

	new Handle:Query;
	Query = SQL_PrepareQuery( SqlConnection, "UPDATE bf2ranks2 SET gold=%i, silver=%i, bronze=%i, highestrank='%s', mostkills='%s', mostwins='%s' WHERE playerid=^"Server^"", gHighest[ hsRankServer ], gMost[ msKillsName ], gMost[ msWinsName ], tempTopName, tempPtsName, tempWinsName );
	if ( !SQL_Execute( Query ) ) {
		Errcode = SQL_QueryError( Query, Error, charsmax( Error ) );
		log_amx( "Save Query failed. [ %d ] %s", Errcode, Error );
	}

	SQL_FreeHandle( Query );
	SQL_FreeHandle( SqlConnection );
}

public TableHandle( FailState, Handle:Query, Error[ ], Errcode, Data[ ], DataSize ) {
	if ( FailState ) {
		if ( FailState == TQUERY_CONNECT_FAILED ) {
			log_amx( "Table - Could not connect to SQL database.  [ %d ] %s", Errcode, Error );
		}
		else if ( FailState == TQUERY_QUERY_FAILED ) {
			log_amx( "Table Query failed. [ %d ] %s", Errcode, Error );
		}

		SQLenabled = false;

		return;
	}

	SQLenabled = true;

	if( SQLenabled ) {
		if ( !gMost[ msWins ] ) {
			server_load( );
		}
	}
}

public QueryHandle( FailState, Handle:Query, Error[ ], Errcode,Data[ ], DataSize ) {
	if ( FailState ) {
		if ( FailState == TQUERY_CONNECT_FAILED ) {
			log_amx( "Save - Could not connect to SQL database.  [ %d ] %s", Errcode, Error );
		}
		else if ( FailState == TQUERY_QUERY_FAILED ) {
			log_amx( "Save Query failed. [ %d ] %s", Errcode, Error );
		}

		return;
	}
}

public SelectHandle( FailState, Handle:Query, Error[ ], Errcode, Data[ ], DataSize ) {
	if ( FailState ) {
		if ( FailState == TQUERY_CONNECT_FAILED ) {
			log_amx( "Load - Could not connect to SQL database.  [ %d ] %s", Errcode, Error );
		}
		else if ( FailState == TQUERY_QUERY_FAILED ) {
			log_amx( "Load Query failed. [ %d ] %s", Errcode, Error );
		}

		return;
	}

	new id = Data[ 0 ];

	if ( !SQL_NumResults( Query ) ) {
		for ( new counter = 0; counter <6 ; counter++ ) {
			g_PlayerBadges[ id ][ counter ] = 0;
		}

		gPlayerStats[ id ][ psKnfie ] = 0;
		gPlayerStats[ id ][ psPistol ] = 0;
		gPlayerStats[ id ][ psSniper ] = 0;
		gPlayerStats[ id ][ psPara ] = 0;
		gPlayerStats[ id ][ psTotal ] = 0;
		gPlayerStats[ id ][ psDefuses ] = 0;
		gPlayerStats[ id ][ psPlants ] = 0;
		gPlayerStats[ id ][ psExplosions ] = 0;

		new tempSaveKey[ 63 ];
		copy( tempSaveKey, charsmax( tempSaveKey ), gSaveKey[ id ] );
		replace_all( tempSaveKey, charsmax( tempSaveKey ), "'", "\'" );

		formatex( g_Cache, charsmax( g_Cache ), "INSERT INTO bf2ranks VALUES( '%s', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0' )", tempSaveKey );
		SQL_ThreadQuery( g_SqlTuple, "QueryHandle", g_Cache );
	}
	else {
		for ( new counter = 0; counter < 6; counter++ ) {
			g_PlayerBadges[ id ][ counter ] = SQL_ReadResult( Query, counter );
		}

		gPlayerStats[ id ][ psKnfie ] = SQL_ReadResult( Query, 6 );
		gPlayerStats[ id ][ psPistol ] = SQL_ReadResult( Query, 7 );
		gPlayerStats[ id ][ psSniper ] = SQL_ReadResult( Query, 8 );
		gPlayerStats[ id ][ psPara ] = SQL_ReadResult( Query, 9 );
		gPlayerStats[ id ][ psTotal ] = SQL_ReadResult( Query, 10 );
		gPlayerStats[ id ][ psDefuses ] = SQL_ReadResult( Query, 11 );
		gPlayerStats[ id ][ psPlants ] = SQL_ReadResult( Query, 12 );
		gPlayerStats[ id ][ psExplosions ] = SQL_ReadResult( Query, 13 );
	}

	gStatsLoaded[ id ]++;
}

public SelectHandle2( FailState, Handle:Query, Error[ ], Errcode, Data[ ], DataSize ) {
	if ( FailState ) {
		if ( FailState == TQUERY_CONNECT_FAILED ) {
			log_amx( "Load - Could not connect to SQL database.  [ %d ] %s", Errcode, Error );
		}
		else if ( FailState == TQUERY_QUERY_FAILED ) {
			log_amx( "Load Query failed. [ %d ] %s", Errcode, Error );
		}

		return;
	}

	new id = Data[ 0 ];

	if ( !SQL_NumResults( Query ) ) {
		for ( new counter = 6; counter < 8; counter++ ) {
			g_PlayerBadges[ id ][ counter ] = 0;
		}

		gPlayerStats[ id ][ psShotgun ] = 0;
		gPlayerStats[ id ][ psSmg ] = 0;
		gPlayerStats[ id ][ psRifle ] = 0;
		gPlayerStats[ id ][ psGrenade ] = 0;
		gPlayerStats[ id ][ psGold ] = 0;
		gPlayerStats[ id ][ psSilver ] = 0;
		gPlayerStats[ id ][ psBronze ] = 0;

		new tempSaveKey[ 63 ];
		copy( tempSaveKey, charsmax( tempSaveKey ), gSaveKey[ id ] );
		replace_all( tempSaveKey, charsmax( tempSaveKey ), "'", "\'" );

		formatex( g_Cache, charsmax( g_Cache ), "INSERT INTO bf2ranks2 VALUES( '%s','0','0','0','0','0','0','0','0','0','0','0','0' )", tempSaveKey );
		SQL_ThreadQuery( g_SqlTuple2, "QueryHandle", g_Cache );
	}
	else {
		g_PlayerBadges[ id ][ 6 ] = SQL_ReadResult( Query, 0 );
		g_PlayerBadges[ id ][ 7 ] = SQL_ReadResult( Query, 1 );
		gPlayerStats[ id ][ psShotgun ] = SQL_ReadResult( Query, 2 );
		gPlayerStats[ id ][ psSmg ] = SQL_ReadResult( Query, 3 );
		gPlayerStats[ id ][ psRifle ] = SQL_ReadResult( Query, 4 );
		gPlayerStats[ id ][ psGrenade ] = SQL_ReadResult( Query, 5 );
		gPlayerStats[ id ][ psGold ] = SQL_ReadResult( Query, 6 );
		gPlayerStats[ id ][ psSilver ] = SQL_ReadResult( Query, 7 );
		gPlayerStats[ id ][ psBronze ] = SQL_ReadResult( Query, 8 );
	}

	gStatsLoaded[ id ]++;
}

public SelectHandleServer( FailState, Handle:Query, Error[ ], Errcode, Data[ ], DataSize ) {
	if ( FailState ) {
		if ( FailState == TQUERY_CONNECT_FAILED ) {
			log_amx( "Load - Could not connect to SQL database.  [ %d ] %s", Errcode, Error );
		}
		else if ( FailState == TQUERY_QUERY_FAILED ) {
			log_amx( "Load Query failed. [ %d ] %s", Errcode, Error );
		}

		return;
	}

	if ( !SQL_NumResults( Query ) ) {
		gHighest[ hsRankServer ] = 0;
		gMost[ msKills ] = 0;
		gMost[ msKillsID ] = 0;
		gMost[ msWins ] = 0;

		SQL_ThreadQuery( g_SqlTuple2, "QueryHandle", "INSERT INTO bf2ranks2 VALUES( 'Server','0','0','0','0','0','0','0','0','0','0','0','0' )" );
		return;
	}

	gHighest[ hsRankServer ] = SQL_ReadResult( Query, 0 );
	gMost[ msKills ] = SQL_ReadResult( Query, 1 );
	gMost[ msWins ] = SQL_ReadResult( Query, 2 );
	SQL_ReadResult( Query, 3, gHighest[ hsRankServerName ], charsmax( gHighest[ hsRankServerName ] ) );
	SQL_ReadResult( Query, 4, gMost[ msKillsName ], charsmax( gMost[ msKillsName ] ) );
	SQL_ReadResult( Query, 5, gMost[ msWinsName ], charsmax( gMost[ msWinsName ] ) );
}